DROP TABLE R;
CREATE TABLE R (A1 INT, A2 VARCHAR(10), A3 BOOLEAN);
INSERT INTO R VALUES
(2,'Kim',true),
(2,'Dad',false),
(3,'Joe',true);

DROP FUNCTION A23 (A1 INT); 
DROP TYPE Atyp; 
CREATE TYPE Atyp AS (A2 VARCHAR(10), A3 BOOLEAN);

CREATE OR REPLACE FUNCTION A23 (A1 INT) RETURNS SETOF Atyp AS 'SELECT A2, A3 FROM R WHERE A1 = $1' Language SQL;
SELECT A1, A23(A1) FROM R GROUP BY A1;

DROP FUNCTION A23 (A1 INT); 
CREATE OR REPLACE FUNCTION A23 (A1 INT) RETURNS SETOF RECORD AS 'SELECT A2, A3 FROM R WHERE A1 = $1' Language SQL;
SELECT A1, A23(A1) FROM R GROUP BY A1;

DROP FUNCTION A23 (A1 INT); 
CREATE OR REPLACE FUNCTION A23 (A1 INT) RETURNS TABLE(A2 VARCHAR(10), A3 BOOLEAN) AS 'SELECT A2, A3 FROM R WHERE A1 = $1' Language SQL;
SELECT A1, A23(A1) FROM R GROUP BY A1;

CREATE TABLE RNF2 (A1 INT, A23 Atyp[]);
INSERT INTO RNF2 SELECT A1, ARRAY(SELECT A23(A1)) FROM R GROUP BY A1;

SELECT * FROM RNF2;

-- UNNEST inner table
SELECT UNNEST(A23) FROM RNF2;

-- PROJECT[PROJECT[A2](A23)](RNF2) 
SELECT ARRAY(SELECT A2 FROM UNNEST(A23)) FROM RNF2;

-- PROJECT[SELECT[A3=true](A23)](RNF2)
SELECT ARRAY(SELECT (A2, A3) FROM UNNEST(A23) WHERE A3 IS TRUE) FROM RNF2;

--SELECT[EXISTS(PROJECT[A2](A23))] (RNF2)
SELECT * FROM RNF2 WHERE EXISTS(SELECT A2 FROM UNNEST(A23));

--SELECT[EXISTS(PROJECT[A2](A23))] (RNF2)
SELECT * FROM RNF2 WHERE EXISTS(SELECT * FROM UNNEST(A23) WHERE A3 IS FALSE);

