<uebung_5>

(: 
   1. Welche Buecher sind von Addison-Wesley nach 1991 publiziert worden?
   Verwenden Sie fuer Ihre Anfrage ein Praedikat in der WHERE-Klausel.  
:)

<result> 
  {
    for $b in fn:doc("bib.xml")/bib/book
    where $b/publisher = "Addison-Wesley" and $b/@year > "1991"
    return <book year="{ $b/@year }">
             { $b/title }
           </book>
 }
</result>

(: 
   2. Verwenden Sie nun ein Praedikat in der FOR-Klausel um den gleichen
   Sachverhalt wie in der vorigen Anfrage auszudruecken. 
:)

<result>
  {
    for $b in fn:doc("bib.xml")/bib/book[publisher = "Addison-Wesley" and
                                         @year > "1991"]
    return <book year="{ $b/@year }">
             { $b/title }
           </book>
 }
</result>

(: 
   3. Bestimmen Sie fuer jedes Buch die Buecher, deren Titel alphabetisch 
   kleiner sind und die mindestens einen gemeinsamen Autor haben.  
   Geben Sie diese Paare von Buechern aus. 
:)

<result>
  {
    for $book1 in fn:doc("bib.xml")//book,
        $book2 in fn:doc("bib.xml")//book,
        $a in $book1/author/last,
        $b in $book2/author/last
    where $book1/title > $book2/title and $a = $b
    return <book-pair>
             { $book1/title }
             { $book2/title }
           </book-pair>
  }
</result>

(: 
   4. Geben Sie zu jedem Buch-Autor-Paar den Titel
   des Buchs und den Autor aus.
:)

<result>
  {
    for $b in fn:doc("bib.xml")//book,
        $a in $b/author
    return <book>
             { $b/title }
             { $a }
           </book>
  }
</result>

(: 
   5. Geben Sie zu jedem Buch dessen Titel und alle seine Autoren aus.
:)

<result>
  {
    for $b in fn:doc("bib.xml")//book
    return <book>
             { $b/title }
             { $b/author }
           </book>
  }
</result>

(: 
   6. Geben Sie fuer jeden eindeutigen Buchtitel
   dessen Titel und Autoren aus.
:)

<result>
  {
    for $a in fn:distinct-values(fn:doc("bib.xml")//book/title)
    return <book>
             <title> { $a } </title>
             {
               fn:doc("bib.xml")/bib/book[title = $a]/author
             }
           </book>
  }
</result>

(: 
   7. Ermitteln Sie alle Buecher, bei denen ein Autor angegeben ist, 
   gefolgt von allen Buechern, bei denen ein Editor angegeben ist. 
   Bei Buechern mit Autoren sollen der Buchtitel und Autor ausgegeben 
   werden; bei Buechern mit Editoren sollen der Buchtitel und die 
   Organisation des Editors ausgegeben werden.
:)

<result>
  {
    for $a in fn:doc("bib.xml")//book[not(empty(author))]
    return <book>
             { $a/title }
             { $a/author }
           </book>
  }
  {
    for $b in fn:doc("bib.xml")//book[not(empty(editor))]
    return <reference>
             { $b/title }
             <org>{ $b/editor/affiliation }</org>
           </reference>
  }
</result>

(: 
   8. Stellen Sie zu jedem Buchtitel aus bib.xml die in prices.xml 
   aufgefuehrten Angebote (als offer-Elemente) dar. Jedes Angebot 
   soll den Anbieter und den Preis umfassen.
:)

<results>
  {
    for $a in fn:doc("bib.xml")/bib/book/title
    return <result>
             { $a }
             {
               for $b in fn:doc("prices.xml")/prices/book
               where $b/title = $a
               return <offer> { $b/source, $b/price } </offer>
             }
           </result>
  }
</results>

</uebung_5>
